diff --git a/oflog/include/dcmtk/oflog/logger.h b/oflog/include/dcmtk/oflog/logger.h
index 81a4026..e9348c7 100644
--- a/oflog/include/dcmtk/oflog/logger.h
+++ b/oflog/include/dcmtk/oflog/logger.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    logger.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,20 +19,24 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
-/** @file
+/** @file 
  * This header defines the Logger class and the logging macros. */
 
-#ifndef DCMTK__LOG4CPLUS_LOGGERHEADER_
-#define DCMTK__LOG4CPLUS_LOGGERHEADER_
+#ifndef DCMTK_LOG4CPLUS_LOGGERHEADER_
+#define DCMTK_LOG4CPLUS_LOGGERHEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/loglevel.h"
 #include "dcmtk/oflog/tstring.h"
-#include "dcmtk/oflog/streams.h"
 #include "dcmtk/oflog/spi/apndatch.h"
 #include "dcmtk/oflog/spi/logfact.h"
 
-//#include <vector>
+#include "dcmtk/ofstd/ofvector.h"
 
 
 namespace dcmtk
@@ -53,76 +58,81 @@ namespace log4cplus
     }
 
 
+    /** \typedef OFVector<Logger> LoggerList
+     * This is a list of {@link Logger Loggers}. */
+    typedef OFVector<Logger> LoggerList;
+
+
     /**
      * This is the central class in the log4cplus package. One of the
      * distintive features of log4cplus are hierarchical loggers and their
      * evaluation.
-     *
+     * 
      * See the <a href="../../../../manual.html">user manual</a> for an
      * introduction on this class.
      */
     class DCMTK_LOG4CPLUS_EXPORT Logger
-        : public spi::AppenderAttachable
+        : public log4cplus::spi::AppenderAttachable
     {
     public:
       // Static Methods
         /**
-         * Returns <code>true </code>if the named logger exists
+         * Returns <code>true </code>if the named logger exists 
          * (in the default hierarchy).
-         *
+         *                
          * @param name The name of the logger to search for.
          */
-        static bool exists(const tstring& name);
+        static bool exists(const log4cplus::tstring& name);
 
         /*
          * Returns all the currently defined loggers in the default
          * hierarchy.
-         *
+         * 
          * The root logger is <em>not</em> included in the returned
-         * list.
+         * list.      
         */
-        static OFList<Logger> getCurrentLoggers();
-
+        static LoggerList getCurrentLoggers();
+     
         /**
          * Return the default Hierarchy instance.
          */
         static Hierarchy& getDefaultHierarchy();
 
         /**
-         * Retrieve a logger with name <code>name</code>.  If the named
-         * logger already exists, then the existing instance will be returned.
-         * Otherwise, a new instance is created.
-         *
+         * Retrieve a logger with name <code>name</code>.  If the named 
+         * logger already exists, then the existing instance will be returned. 
+         * Otherwise, a new instance is created. 
+         * 
          * By default, loggers do not have a set LogLevel but inherit
          * it from the hierarchy. This is one of the central features of
          * log4cplus.
-         *
-         * @param name The name of the logger to retrieve.
+         * 
+         * @param name The name of the logger to retrieve.  
          */
-        static Logger getInstance(const tstring& name);
+        static Logger getInstance(const log4cplus::tstring& name);
 
         /**
          * Like getInstance() except that the type of logger
          * instantiated depends on the type returned by the {@link
          * spi::LoggerFactory#makeNewLoggerInstance} method of the
          * <code>factory</code> parameter.
-         *
+         *                          
          * This method is intended to be used by sub-classes.
-         *
+         *                                   
          * @param name The name of the logger to retrieve.
          * @param factory A {@link spi::LoggerFactory} implementation that will
          * actually create a new Instance.
          */
-        static Logger getInstance(const tstring& name, spi::LoggerFactory& factory);
+        static Logger getInstance(const log4cplus::tstring& name, spi::LoggerFactory& factory);
 
         /**
          * Return the root of the default logger hierrachy.
-         *
+         * 
          * The root logger is always instantiated and available. It's
          * name is "root".
-         *
+         * 
          * Nevertheless, calling {@link #getInstance
-         * Logger.getInstance("root")} does not retrieve the root logger
+         * Logger.getInstance("root")} does not retrieve the root logger 
          * but a logger just under root named "root".
          */
         static Logger getRoot();
@@ -131,15 +141,15 @@ namespace log4cplus
          * Calling this method will <em>safely</em> close and remove all
          * appenders in all the loggers including root contained in the
          * default hierachy.
-         *
+         *                     
          * Some appenders such as SocketAppender need to be closed before the
          * application exits. Otherwise, pending logging events might be
          * lost.
-         *
+         * 
          * The <code>shutdown</code> method is careful to close nested
          * appenders before closing regular appenders. This is allows
          * configurations where a regular appender is attached to a logger
-         * and again to a nested appender.
+         * and again to a nested appender.  
          */
         static void shutdown();
 
@@ -152,11 +162,11 @@ namespace log4cplus
          * @param msg The message to print if <code>assertion</code> is
          * false.
          */
-        void assertion(bool assertionVal, const tstring& msg) const;
+        void assertion(bool assertionVal, const log4cplus::tstring& msg) const;
 
         /**
          * Close all attached appenders implementing the AppenderAttachable
-         * interface.
+         * interface.  
          */
         void closeNestedAppenders() const;
 
@@ -169,25 +179,27 @@ namespace log4cplus
         bool isEnabledFor(LogLevel ll) const;
 
         /**
-         * This generic form is intended to be used by wrappers.
+         * This generic form is intended to be used by wrappers. 
          */
-        void log(LogLevel ll, const tstring& message,
-                 const char* file=NULL, int line=-1,
-                 const char* function=NULL) const;
+        void log(LogLevel ll, const log4cplus::tstring& message,
+                 const char* file=NULL, int line=-1) const;
+
+        void log(spi::InternalLoggingEvent const &) const;
 
         /**
          * This method creates a new logging event and logs the event
-         * without further checks.
+         * without further checks.  
          */
-        void forcedLog(LogLevel ll, const tstring& message,
-                       const char* file=NULL, int line=-1,
-                       const char* function=NULL) const;
+        void forcedLog(LogLevel ll, const log4cplus::tstring& message,
+                       const char* file=NULL, int line=-1) const;
+
+        void forcedLog(spi::InternalLoggingEvent const &) const;
 
         /**
          * Call the appenders in the hierrachy starting at
          * <code>this</code>.  If no appenders could be found, emit a
          * warning.
-         *
+         * 
          * This method calls all the appenders inherited from the
          * hierarchy circumventing any evaluation of whether to log or not
          * to log the particular log request.
@@ -200,15 +212,15 @@ namespace log4cplus
          * Starting from this logger, search the logger hierarchy for a
          * "set" LogLevel and return it. Otherwise, return the LogLevel of the
          * root logger.
-         *
+         * 
          * The Logger class is designed so that this method executes as
          * quickly as possible.
          */
         LogLevel getChainedLogLevel() const;
 
         /**
-         * Returns the assigned LogLevel, if any, for this Logger.
-         *
+         * Returns the assigned LogLevel, if any, for this Logger.  
+         *           
          * @return LogLevel - the assigned LogLevel, can be <code>NOT_SET_LOG_LEVEL</code>.
          */
         LogLevel getLogLevel() const;
@@ -225,12 +237,12 @@ namespace log4cplus
         Hierarchy& getHierarchy() const;
 
         /**
-         * Return the logger name.
+         * Return the logger name.  
          */
-        tstring getName() const;
+        log4cplus::tstring const & getName() const;
 
         /**
-         * Get the additivity flag for this Logger instance.
+         * Get the additivity flag for this Logger instance.  
          */
         bool getAdditivity() const;
 
@@ -244,17 +256,21 @@ namespace log4cplus
 
         virtual SharedAppenderPtrList getAllAppenders();
 
-        virtual SharedAppenderPtr getAppender(const tstring& name);
+        virtual SharedAppenderPtr getAppender(const log4cplus::tstring& name);
 
         virtual void removeAllAppenders();
 
         virtual void removeAppender(SharedAppenderPtr appender);
 
-        virtual void removeAppender(const tstring& name);
+        virtual void removeAppender(const log4cplus::tstring& name);
 
         Logger ();
         Logger(const Logger& rhs);
         Logger& operator=(const Logger& rhs);
+#if defined (DCMTK_LOG4CPLUS_HAVE_RVALUE_REFS)
+        Logger (Logger && rhs);
+        Logger & operator = (Logger && rhs);
+#endif
         virtual ~Logger();
 
         void swap (Logger &);
@@ -273,81 +289,36 @@ namespace log4cplus
     private:
       // Ctors
         /**
-         * This constructor created a new <code>Logger</code> instance
+         * This constructor created a new <code>Logger</code> instance 
          * with a pointer to a Logger implementation.
-         *
+         * 
          * You should not create loggers directly.
          *
          * @param ptr A pointer to the Logger implementation.  This value
-         *            cannot be NULL.
+         *            cannot be NULL.  
          */
-        Logger(spi::LoggerImpl * ptr);
+        DCMTK_LOG4CPLUS_PRIVATE Logger(spi::LoggerImpl * ptr);
 
       // Friends
-        friend class spi::LoggerImpl;
-        friend class Hierarchy;
-        friend class HierarchyLocker;
-        friend class DefaultLoggerFactory;
+        friend class log4cplus::spi::LoggerImpl;
+        friend class log4cplus::Hierarchy;
+        friend class log4cplus::HierarchyLocker;
+        friend class log4cplus::DefaultLoggerFactory;
     };
 
 
-    /** \typedef OFList<Logger> LoggerList
-     * This is a list of {@link Logger Loggers}. */
-    typedef OFList<Logger> LoggerList;
-    typedef OFListIterator(Logger) LoggerListIterator;
-
-
     /**
      * This class is used to create the default implementation of
      * the Logger class
      */
     class DCMTK_LOG4CPLUS_EXPORT DefaultLoggerFactory : public spi::LoggerFactory {
     public:
-        Logger makeNewLoggerInstance(const tstring& name, Hierarchy& h);
+        Logger makeNewLoggerInstance(const log4cplus::tstring& name, Hierarchy& h);
     };
 
 
-
-    /**
-     * This class is used to produce "Trace" logging.  When an instance of
-     * this class is created, it will log a <code>"ENTER: " + msg</code>
-     * log message if TRACE_LOG_LEVEL is enabled for <code>logger</code>.
-     * When an instance of this class is destroyed, it will log a
-     * <code>"ENTER: " + msg</code> log message if TRACE_LOG_LEVEL is enabled
-     * for <code>logger</code>.
-     *
-     * @see DCMTK_LOG4CPLUS_TRACE
-     */
-    class TraceLogger
-    {
-    public:
-        TraceLogger(const Logger& l, const tstring& _msg,
-                    const char* _file=NULL, int _line=-1)
-          : logger(l), msg(_msg), file(_file), line(_line)
-        { if(logger.isEnabledFor(TRACE_LOG_LEVEL))
-              logger.forcedLog(TRACE_LOG_LEVEL, DCMTK_LOG4CPLUS_TEXT("ENTER: ") + msg, file, line);
-        }
-
-        ~TraceLogger()
-        { if(logger.isEnabledFor(TRACE_LOG_LEVEL))
-              logger.forcedLog(TRACE_LOG_LEVEL, DCMTK_LOG4CPLUS_TEXT("EXIT:  ") + msg, file, line);
-        }
-
-    private:
-        TraceLogger(const TraceLogger&);
-        TraceLogger& operator=(const TraceLogger&);
-        Logger logger;
-        tstring msg;
-        const char* file;
-        int line;
-    };
-
 } // end namespace log4cplus
 } // end namespace dcmtk
 
 
-#include "dcmtk/oflog/logmacro.h"
-
-
-#endif // DCMTK__LOG4CPLUS_LOGGERHEADER_
-
+#endif // DCMTK_LOG4CPLUS_LOGGERHEADER_
diff --git a/oflog/include/dcmtk/oflog/loglevel.h b/oflog/include/dcmtk/oflog/loglevel.h
index 6b8ccd5..54a0681 100644
--- a/oflog/include/dcmtk/oflog/loglevel.h
+++ b/oflog/include/dcmtk/oflog/loglevel.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    loglevel.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,7 +19,7 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
-/** @file
+/** @file 
  * This header defines the LogLevel type.
  */
 
@@ -26,20 +27,24 @@
 #define DCMTK_LOG4CPLUS_LOGLEVEL_HEADER_
 
 #include "dcmtk/oflog/config.h"
-#include "dcmtk/oflog/streams.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/ofstd/ofvector.h"
 #include "dcmtk/oflog/tstring.h"
 
-//#include <vector>
 
 namespace dcmtk {
 namespace log4cplus {
 
-    /**
+    /** 
      * \typedef int LogLevel
      * Defines the minimum set of priorities recognized by the system,
-     * that is {@link FATAL_LOG_LEVEL}, {@link ERROR_LOG_LEVEL}, {@link
-     * WARN_LOG_LEVEL}, {@link INFO_LOG_LEVEL}, {@link DEBUG_LOG_LEVEL},
-     * and {@link TRACE_LOG_LEVEL}.
+     * that is {@link #FATAL_LOG_LEVEL}, {@link #ERROR_LOG_LEVEL}, {@link
+     * #WARN_LOG_LEVEL}, {@link #INFO_LOG_LEVEL}, {@link #DEBUG_LOG_LEVEL}, 
+     * and {@link #TRACE_LOG_LEVEL}.
      */
     typedef int LogLevel;
 
@@ -59,13 +64,13 @@ namespace log4cplus {
     const LogLevel ERROR_LOG_LEVEL   = 40000;
 
     /** \var const LogLevel WARN_LOG_LEVEL
-     * The <code>WARN_LOG_LEVEL</code> LogLevel designates potentially harmful
+     * The <code>WARN_LOG_LEVEL</code> LogLevel designates potentially harmful 
      * situations. */
     const LogLevel WARN_LOG_LEVEL    = 30000;
 
     /** \var const LogLevel INFO_LOG_LEVEL
-     * The <code>INFO_LOG_LEVEL</code> LogLevel designates informational
-     * messages  that highlight the progress of the application at
+     * The <code>INFO_LOG_LEVEL</code> LogLevel designates informational 
+     * messages  that highlight the progress of the application at 
      * coarse-grained  level. */
     const LogLevel INFO_LOG_LEVEL    = 20000;
 
@@ -78,7 +83,7 @@ namespace log4cplus {
      * The <code>TRACE_LOG_LEVEL</code> LogLevel is used to "trace" entry
      * and exiting of methods. */
     const LogLevel TRACE_LOG_LEVEL   = 0;
-
+    
     /** \var const LogLevel ALL_LOG_LEVEL
      * The <code>ALL_LOG_LEVEL</code> LogLevel is used during configuration to
      * turn on all logging. */
@@ -91,23 +96,27 @@ namespace log4cplus {
     const LogLevel NOT_SET_LOG_LEVEL = -1;
 
 
-    /**
+    /** 
      * This method type defined the signature of methods that convert LogLevels
-     * into strings.
-     *
+     * into strings. 
+     * 
      * <b>Note:</b> Must return an empty <code>tstring</code> for unrecognized values.
      */
-    typedef tstring (*LogLevelToStringMethod)(LogLevel);
+    typedef log4cplus::tstring const & (*LogLevelToStringMethod)(LogLevel);
 
-    /**
+    //! This function type is for log4cplus 1.0.x callbacks.
+    typedef log4cplus::tstring (*LogLevelToStringMethod_1_0) (LogLevel);
+
+
+    /** 
      * This method type defined the signature of methods that convert strings
-     * into LogLevels.
-     *
+     * into LogLevels. 
+     * 
      * <b>Note:</b> Must return <code>NOT_SET_LOG_LEVEL</code> for unrecognized values.
      */
-    typedef LogLevel (*StringToLogLevelMethod)(const tstring&);
-
+    typedef LogLevel (*StringToLogLevelMethod)(const log4cplus::tstring&);
 
+    
 
     /**
      * This class is used to "manage" LogLevel definitions.  This class is also
@@ -130,43 +139,59 @@ namespace log4cplus {
         /**
          * This method is called by all Layout classes to convert a LogLevel
          * into a string.
-         *
+         * 
          * Note: It traverses the list of <code>LogLevelToStringMethod</code>
          *       to do this, so all "derived" LogLevels are recognized as well.
          */
-        tstring toString(LogLevel ll) const;
-
+        log4cplus::tstring const & toString(LogLevel ll) const;
+        
         /**
          * This method is called by all classes internally to log4cplus to
          * convert a string into a LogLevel.
-         *
+         * 
          * Note: It traverses the list of <code>StringToLogLevelMethod</code>
          *       to do this, so all "derived" LogLevels are recognized as well.
          */
-        LogLevel fromString(const tstring& s) const;
+        LogLevel fromString(const log4cplus::tstring& s) const;
 
         /**
          * When creating a "derived" LogLevel, a <code>LogLevelToStringMethod</code>
          * should be defined and registered with the LogLevelManager by calling
          * this method.
-         *
+         * 
          * @see pushFromStringMethod
          */
         void pushToStringMethod(LogLevelToStringMethod newToString);
 
+        //! For compatibility with log4cplus 1.0.x.
+        void pushToStringMethod(LogLevelToStringMethod_1_0 newToString);
+
         /**
          * When creating a "derived" LogLevel, a <code>StringToLogLevelMethod</code>
          * should be defined and registered with the LogLevelManager by calling
          * this method.
-         *
+         * 
          * @see pushToStringMethod
          */
         void pushFromStringMethod(StringToLogLevelMethod newFromString);
 
     private:
       // Data
-        void* toStringMethods;
-        void* fromStringMethods;
+        struct LogLevelToStringMethodRec
+        {
+            union
+            {
+                LogLevelToStringMethod func;
+                LogLevelToStringMethod_1_0 func_1_0;
+            };
+            bool use_1_0;
+        };
+
+        typedef OFVector<LogLevelToStringMethodRec> LogLevelToStringMethodList;
+        LogLevelToStringMethodList toStringMethods;
+
+        typedef OFVector<StringToLogLevelMethod> StringToLogLevelMethodList;
+        StringToLogLevelMethodList fromStringMethods;
 
       // Disable Copy
         LogLevelManager(const LogLevelManager&);
@@ -179,7 +204,7 @@ namespace log4cplus {
     DCMTK_LOG4CPLUS_EXPORT LogLevelManager& getLogLevelManager();
 
 }
-}
+} // end namespace dcmtk
 
 
 #endif // DCMTK_LOG4CPLUS_LOGLEVEL_HEADER_
